<!doctype html>
<html lang="en">

<head>
  <meta charset="utf-8">

  <title>Functional programing</title>

  <meta name="description" content="">
  <meta name="author" content="">

  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">
  <!-- REVEAL CSS-->
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.5.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="libs/reveal.js/dist/reset.css">
  <link rel="stylesheet" href="libs/reveal.js/dist/reveal.css">
  
  <link rel="stylesheet" href="libs/reveal.js/dist/theme/solarized.css" id="theme">
  
  
  <!--
  <link rel="stylesheet" href="libs/reveal.js/plugin/title-footer/title-footer-mod.css" />
  -->

  <!-- MERMAID-->
  <!--
  <script src="libs/reveal.js/plugin/mermaid/mermaid.min.js"></script>
  <style>
  .mermaid {
    font-size: 0.5em;
  }
  </style>
  -->
  
  <style>
    [class*=task-list-item] {
      min-height: 22px;
      margin-top: 6px!important;
      margin-bottom: 6px!important;
      padding-left: 0;
      list-style: none;
    }

    [class*=task-list-item]>input:first-child {
      position: absolute!important;
      opacity: 0;
      margin: 0;
    }

    [class*=task-list-item]>label {
      padding-left: 29px!important;
      min-height: 22px;
      line-height: 22px;
      display: inline-block;
      position: relative;
      vertical-align: top;
      margin-bottom: 0;
      font-weight: 400;
      cursor: pointer;
    }

    .task-list-item>input:first-child:checked+input[type=hidden]+label::before, .task-list-item>input:first-child:checked+label::before {
      background-color: #ecf0f1;
      border-color: #ecf0f1;
    }

    [class*=task-list-item]>input:first-child+input[type=hidden]+label::before, [class*=task-list-item]>input:first-child+label::before {
      content: "";
      display: inline-block;
      position: absolute;
      width: 22px;
      height: 22px;
      border: 1px solid #D3CFC8;
      border-radius: 0;
      margin-left: -29px;
    }

    [class*=task-list-item]>input:first-child:checked+input[type=hidden]+label::after, [class*=task-list-item]>input:first-child:checked+label::after {
      content: "";
      display: inline-block;
      position: absolute;
      top: 0;
      left: 0;
      width: 7px;
      height: 10px;
      border: 2px solid #fff;
      border-left: none;
      border-top: none;
      transform: translate(7.75px,4.5px) rotate(45deg);
      -ms-transform: translate(7.75px,4.5px) rotate(45deg);
    }

    .task-list-item>input:first-child:checked+input[type=hidden]+label::after, .task-list-item>input:first-child:checked+label::after {
      border-bottom-color: #95a5a6;
      border-right-color: #95a5a6;
    }
  </style>

  <!-- Theme used for syntax highlighting of code -->
  
  <link rel="stylesheet" href="libs/reveal.js/plugin/highlight/Zenburn.css">
  

  
  
  <!-- Printing and PDF exports -->
  <script>
    var link = document.createElement('link');
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = window.location.search.match(/print-pdf/gi) ? 'libs/reveal.js/dist/print/pdf.css' : 'libs/reveal.js/dist/print/paper.css';
    document.getElementsByTagName('head')[0].appendChild(link);
  </script>

  <style>
     .line {
      display: block;
    }   

    .line.focus {
      background: #fdf6e3;
      color: #657b83;
    }

    .reveal .slides section .fragment.current-only {
      visibility: visible;
      display: none;
    }

    .reveal .slides section .fragment.current-only.current-fragment {
      display: block;
    }

    .line.focus {
       opacity: 1.0;
    } 

    @media (device-width: 100vw) and (device-height: 100vh) {
      .reveal pre code {
        max-height: 50vh !important;
      }
    }

    #logo img {
      max-height: 3.5em;
      max-width: none;
      min-width: 50px;
    }

    .reveal .slides section .code-presenting-annotation {
      color: white;
      background: black;
      padding: 0px 15px;
      border-radius: 15px;
      opacity: 0.75 !important;
      font-size: 50% !important;
    }
  </style>
  <script>
    if (window.location.search.match(/print-pdf-now/gi)) {
      window.print();
    }
  </script>
</head>

<body>
  

  <div class="reveal">

    <!-- Any section element inside of this container is displayed as a slide -->
    <div class="slides">

      
  
    <section>
      <section >
        <h2><a id="user-content-functional-reactive-programming" class="anchor" href="#functional-reactive-programming" aria-hidden="true"></a>Functional reactive programming</h2>
<p>Functional reactive programming (FRP) is a programming paradigm for reactive programming (asynchronous dataflow programming) using the building blocks of functional programming (e.g. map, reduce, filter). FRP has been used for programming graphical user interfaces (GUIs), robotics, games, and music, aiming to simplify these problems by explicitly modeling time.
<a href="https://en.wikipedia.org/wiki/Functional_reactive_programming">https://en.wikipedia.org/wiki/Functional_reactive_programming</a>
<a href="https://confluence.atalink.com/display/DEVELOPMENT/Web">https://confluence.atalink.com/display/DEVELOPMENT/Web</a></p>

      </section>
      
        <section >
          <h2><a id="user-content-functional-programing" class="anchor" href="#functional-programing" aria-hidden="true"></a>Functional programing</h2>
<p>Functional programming languages are specially designed to handle symbolic computation and list processing applications. Functional programming is based on mathematical functions. Some of the popular functional programming languages include: Lisp, Python, Erlang, Haskell, Clojure, etc.</p>

        </section>
      
        <section >
          <p>Functional programming languages are categorized into two groups, i.e. −</p>
<ul>
<li>
<p><strong>Pure Functional Languages</strong> − These types of functional languages support only the functional paradigms. For example − Haskell.</p>
</li>
<li>
<p><strong>Impure Functional Languages</strong> − These types of functional languages support the functional paradigms and imperative style programming. For example − LISP.</p>
</li>
</ul>

        </section>
      
    </section>
  

  
    <section>
      <section >
        <h2><a id="user-content-functional-programming--characteristics" class="anchor" href="#functional-programming--characteristics" aria-hidden="true"></a>Functional Programming – Characteristics</h2>
<p>The most prominent characteristics of functional programming are as follows</p>

      </section>
      
        <section >
          <ul>
<li>
<p>Functional programming languages are designed on the concept of mathematical functions that use conditional expressions and recursion to perform computation.</p>
</li>
<li>
<p>Functional programming supports higher-order functions and lazy evaluation features.</p>
</li>
</ul>

        </section>
      
        <section >
          <ul>
<li>
<p>Functional programming languages don’t support flow Controls like loop statements and conditional statements like If-Else and Switch Statements. They directly use the functions and functional calls.</p>
</li>
<li>
<p>Like OOP, functional programming languages support popular concepts such as Abstraction, Encapsulation, Inheritance, and Polymorphism.</p>
</li>
</ul>

        </section>
      
    </section>
  

  
    <section>
      <section >
        <h2><a id="user-content-functional-programming--advantages" class="anchor" href="#functional-programming--advantages" aria-hidden="true"></a>Functional Programming – Advantages</h2>
<p>Functional programming offers the following advantages −</p>

      </section>
      
        <section >
          <ul>
<li>
<p>Bugs-Free Code − Functional programming does not support state, so there are no side-effect results and we can write error-free codes.</p>
</li>
<li>
<p>Efficient Parallel Programming − Functional programming languages have NO Mutable state, so there are no state-change issues. One can program “Functions” to work parallel as “instructions”. Such codes support easy reusability and testability.</p>
</li>
</ul>

        </section>
      
        <section >
          <ul>
<li>
<p>Efficiency − Functional programs consist of independent units that can run concurrently. As a result, such programs are more efficient.</p>
</li>
<li>
<p>Supports Nested Functions − Functional programming supports Nested Functions.</p>
</li>
<li>
<p>Lazy Evaluation − Functional programming supports Lazy Functional Constructs like Lazy Lists, Lazy Maps, etc.</p>
</li>
</ul>

        </section>
      
    </section>
  

  
    <section >
      <h2><a id="user-content-functional-programming--disadvantages" class="anchor" href="#functional-programming--disadvantages" aria-hidden="true"></a>Functional Programming – Disadvantages</h2>
<p>As a downside, functional programming requires a large memory space. As it does not have state, you need to create new objects every time to perform actions.</p>

    </section>
  

  
    <section >
      <h2><a id="user-content-functional-programming--usecase" class="anchor" href="#functional-programming--usecase" aria-hidden="true"></a>Functional Programming – Usecase</h2>
<p>Functional Programming is used in situations where we have to perform lots of different operations on the same set of data.</p>
<ul>
<li>
<p>Lisp is used for artificial intelligence applications like Machine learning, language processing, Modeling of speech and vision, etc.</p>
</li>
<li>
<p>Embedded Lisp interpreters add programmability to some systems like Emacs.</p>
</li>
</ul>

    </section>
  

  
    <section >
      <h3><a id="user-content-functional-programming-vs-object-oriented-programming" class="anchor" href="#functional-programming-vs-object-oriented-programming" aria-hidden="true"></a>Functional Programming vs. Object-oriented Programming</h3>
<p>The following table highlights the major differences between functional programming and object-oriented programming</p>

    </section>
  

  
    <section>
      <section >
        <table>
<thead>
<tr>
<th>Functional Programming</th>
<th>OOP</th>
</tr>
</thead>
<tbody>
<tr>
<td>Uses Immutable data.</td>
<td>Uses Mutable data.</td>
</tr>
<tr>
<td>Follows Declarative Programming Model.</td>
<td>Follows Imperative Programming Model.</td>
</tr>
<tr>
<td>Focus is on: “What you are doing”</td>
<td>Focus is on “How you are doing”</td>
</tr>
<tr>
<td>Supports Parallel Programming</td>
<td>Not suitable for Parallel Programming</td>
</tr>
<tr>
<td>Its functions have no-side effects</td>
<td>Its methods can produce serious side effects.</td>
</tr>
</tbody>
</table>

      </section>
      
        <section >
          <table>
<thead>
<tr>
<th>Functional Programming</th>
<th>OOP</th>
</tr>
</thead>
<tbody>
<tr>
<td>Flow Control is done using function calls &amp; function calls with recursion</td>
<td>Flow control is done using loops and conditional statements.</td>
</tr>
<tr>
<td>It uses “Recursion” concept to iterate Collection Data.</td>
<td>It uses “Loop” concept to iterate Collection Data. For example: For-each loop in Java</td>
</tr>
<tr>
<td>Execution order of statements is not so important.</td>
<td>Execution order of statements is very important.</td>
</tr>
<tr>
<td>Supports both “Abstraction over Data” and “Abstraction over Behavior”.</td>
<td>Supports only “Abstraction over Data”.</td>
</tr>
</tbody>
</table>

        </section>
      
    </section>
  



    </div>

  </div>

  <script src="libs/reveal.js/dist/reveal.js"></script>

<script src="libs/reveal.js/plugin/zoom/zoom.js"></script>

<script src="libs/reveal.js/plugin/notes/notes.js"></script>
<script src="libs/reveal.js/plugin/search/search.js"></script>
<script src="libs/reveal.js/plugin/markdown/markdown.js"></script>
<script src="libs/reveal.js/plugin/highlight/highlight.js"></script>
<script src="libs/reveal.js/plugin/math/math.js"></script>
<script>
    // More info https://github.com/hakimel/reveal.js#configuration
    Reveal.initialize({

        controls: true,
        controlsTutorial: true,
        controlsLayout: 'bottom-right',
        controlsBackArrows: 'faded',
        progress: true,
        slideNumber: false,
        history: true,
        keyboard: true,
        overview: true,
        center: false,
        touch: true,
        loop: false,
        rtl: false,
        shuffle: false,
        fragments: true,
        fragmentInURL: false,
        embedded: false,
        help: true,
        showNotes: false,
        autoPlayMedia: false,
        autoSlide: 0,
        autoSlideStoppable: true,
        autoSlideMethod: Reveal.navigateNext,
        defaultTiming: 120,
        mouseWheel: false,
        hideAddressBar: true,
        previewLinks: false,
        transition: 'slide',
        transitionSpeed: 'default',
        backgroundTransition: 'default',
        viewDistance: 3,
        parallaxBackgroundImage: '',
        parallaxBackgroundSize: '',
        parallaxBackgroundHorizontal: 0,
        parallaxBackgroundVertical: 0,
        display: 'block',

        plugins: [RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight, RevealMath],
        
        math: {
            mathjax: 'https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/MathJax.js',
            config: 'TeX-AMS_HTML-full',
            TeX: { Macros: { RR: "{\\bf R}" } }
        },
        /*
        // More info https://github.com/hakimel/reveal.js#dependencies
        dependencies: [
            
            { src: 'libs/reveal.js/3.8.0/plugin/search/search.js', async: true },
            

            
            { src: 'libs/reveal.js-plugins/3.8.0/plugin/chalkboard/chalkboard.js' },
                

            
            { src: 'libs/reveal.js/3.8.0/plugin/menu/menu.js' },
            

            
            { src: 'libs/reveal.js/3.8.0/plugin/title-footer/title-footer.js', async: true, callback: function () { title_footer.initialize(); } },
            
            {
                src: 'libs/highlight.js/9.15.10/reveal-code-focus-1.0.0-mod.js',
                async: true,
                callback: function () {
                    RevealCodeFocus();
                }
            },
            // {src: 'libs/reveal.js/3.8.0/plugin/line-numbers/line-numbers.js'}
        ],
        keyboard: {
            67: function () { RevealChalkboard.toggleNotesCanvas() },	// toggle notes canvas when 'c' is pressed
            66: function () { RevealChalkboard.toggleChalkboard() },	// toggle chalkboard when 'b' is pressed
            46: function () { RevealChalkboard.clear() },	// clear chalkboard when 'DEL' is pressed
            8: function () { RevealChalkboard.reset() },	// reset chalkboard data on current slide when 'BACKSPACE' is pressed
            68: function () { RevealChalkboard.download() },	// downlad recorded chalkboard drawing when 'd' is pressed
        },
        chart: {
            defaults: {
                global: {
                    title: { fontColor: "#FFF" },
                    legend: {
                        position: "bottom",
                            labels: { fontColor: "#FFF" },
                    },
                    tooltips: {
                        labels: { fontColor: "#FFF" },
                    },
                },
                scale: {
                    scaleLabel: { fontColor: "#FFF" },
                    gridLines: { color: "#FFF", zeroLineColor: "#FFF" },
                    ticks: { fontColor: "#FFF" },
                }
            },
            line: { borderColor: ["rgba(20,220,220,.8)", "rgba(220,120,120,.8)", "rgba(20,120,220,.8)"], "borderDash": [[5, 10], [0, 0]] },
            bar: { backgroundColor: ["rgba(20,220,220,.8)", "rgba(220,120,120,.8)", "rgba(20,120,220,.8)"] },
            pie: { backgroundColor: [["rgba(0,0,0,.8)", "rgba(220,20,20,.8)", "rgba(20,220,20,.8)", "rgba(220,220,20,.8)", "rgba(20,20,220,.8)"]] },
            radar: { borderColor: ["rgba(20,220,220,.8)", "rgba(220,120,120,.8)", "rgba(20,120,220,.8)"] },
        },
        anything: [ 
            {
                className: "mermaid"
            },
            // ...
        ],
        menu: {
            // Specifies which side of the presentation the menu will 
            // be shown. Use 'left' or 'right'.
            side: 'left',

                // Specifies the width of the menu.
                // Can be one of the following:
                // 'normal', 'wide', 'third', 'half', 'full', or
                // any valid css length value
                width: 'normal',

                    // Add slide numbers to the titles in the slide list.
                    // Use 'true' or format string (same as reveal.js slide numbers)
                    numbers: false,

                        // Specifies which slide elements will be used for generating
                        // the slide titles in the menu. The default selects the first
                        // heading element found in the slide, but you can specify any
                        // valid css selector and the text from the first matching
                        // element will be used.
                        // Note: that a section data-menu-title attribute or an element
                        // with a menu-title class will take precedence over this option
                        titleSelector: 'h1, h2, h3, h4, h5, h6',

                            // If slides do not have a matching title, attempt to use the
                            // start of the text content as the title instead
                            useTextContentForMissingTitles: false,

                                // Hide slides from the menu that do not have a title.
                                // Set to 'true' to only list slides with titles.
                                hideMissingTitles: false,

                                    // Adds markers to the slide titles to indicate the 
                                    // progress through the presentation. Set to 'false'
                                    // to hide the markers.
                                    markers: true,

                                        // Specify custom panels to be included in the menu, by
                                        // providing an array of objects with 'title', 'icon'
                                        // properties, and either a 'src' or 'content' property.
                                        // custom: false,
                                        custom: [],
                                            // Specifies the themes that will be available in the themes
                                            // menu panel. Set to 'true' to show the themes menu panel
                                            // with the default themes list. Alternatively, provide an
                                            // array to specify the themes to make available in the
                                            // themes menu panel, for example...
                                            // [
                                            //     { name: 'Black', theme: 'css/theme/black.css' },
                                            //     { name: 'White', theme: 'css/theme/white.css' },
                                            //     { name: 'League', theme: 'css/theme/league.css' }
                                            // ]
                                            themes: false,

                                                // Specifies the path to the default theme files. If your
                                                // presentation uses a different path to the standard reveal
                                                // layout then you need to provide this option, but only
                                                // when 'themes' is set to 'true'. If you provide your own 
                                                // list of themes or 'themes' is set to 'false' the 
                                                // 'themesPath' option is ignored.
                                                themesPath: 'css/theme/',

                                                    // Specifies if the transitions menu panel will be shown.
                                                    // Set to 'true' to show the transitions menu panel with
                                                    // the default transitions list. Alternatively, provide an
                                                    // array to specify the transitions to make available in
                                                    // the transitions panel, for example...
                                                    // ['None', 'Fade', 'Slide']
                                                    transitions: false,

                                                        // Adds a menu button to the slides to open the menu panel.
                                                        // Set to 'false' to hide the button.
                                                        openButton: true,

                                                            // If 'true' allows the slide number in the presentation to
                                                            // open the menu panel. The reveal.js slideNumber option must 
                                                            // be displayed for this to take effect
                                                            openSlideNumber: false,

                                                                // If true allows the user to open and navigate the menu using
                                                                // the keyboard. Standard keyboard interaction with reveal
                                                                // will be disabled while the menu is open.
                                                                keyboard: true,

                                                                    // Normally the menu will close on user actions such as
                                                                    // selecting a menu item, or clicking the presentation area.
                                                                    // If 'true', the sticky option will leave the menu open
                                                                    // until it is explicitly closed, that is, using the close
                                                                    // button or pressing the ESC or m key (when the keyboard 
                                                                    // interaction option is enabled).
                                                                    sticky: false,

                                                                        // If 'true' standard menu items will be automatically opened
                                                                        // when navigating using the keyboard. Note: this only takes 
                                                                        // effect when both the 'keyboard' and 'sticky' options are enabled.
                                                                        autoOpen: true,

                                                                            // If 'true' the menu will not be created until it is explicitly
                                                                            // requested by calling RevealMenu.init(). Note this will delay
                                                                            // the creation of all menu panels, including custom panels, and
                                                                            // the menu button.
                                                                            delayInit: false,

                                                                                // If 'true' the menu will be shown when the menu is initialised.
                                                                                openOnInit: false,

                                                                                    // By default the menu will load it's own font-awesome library
                                                                                    // icons. If your presentation needs to load a different
                                                                                    // font-awesome library the 'loadIcons' option can be set to false
                                                                                    // and the menu will not attempt to load the font-awesome library.
                                                                                    loadIcons: false
        },
        chalkboard: {
            toggleChalkboardButton: { left: "60px", bottom: "30px", top: "auto", right: "auto" },
            toggleNotesButton: { left: "90px", bottom: "30px", top: "auto", right: "auto" },

        }
        */
    });

</script>


</body>

</html>
